#ifndef XPLODELISTENER_H
#define XPLODELISTENER_H

// Qt includes
#include <qpalette.h>
#include <qstring.h>
#include <qprogressdialog.h>
#include <qtimer.h>
#include <qprocess.h>
#include <qmsgbox.h>
#include <qfiledialog.h>
#include <qtextedit.h>
#include <qevent.h>
#include <qdragobject.h>

// This class provides the listener, a connection with the MzPlasm server
class XplodeListener : public QTextEdit
{
        Q_OBJECT

public:
        XplodeListener(QWidget *parent = 0, const char *name = 0);
        ~XplodeListener();

        void updateFont();

        bool openConnection();
        bool reconnect();
        void closeConnection();

        void eval(QString code);
        bool isConnected();

protected:
        virtual void keyPressEvent(QKeyEvent * event);
        void startDrag();
        virtual void contentsMousePressEvent(QMouseEvent *event);
        virtual void contentsMouseMoveEvent(QMouseEvent *event);
        virtual void contentsDragEnterEvent (QDragEnterEvent *event);
        virtual void contentsDragMoveEvent (QDragMoveEvent *event);
        virtual void contentsDropEvent (QDropEvent *event);

private:
        QProcess *mzplasm;
        QPoint dragPos;

        bool connected, ready;
public slots:
        void receive();
signals:
        void startEvaluation();
        void stopEvaluation();
        void exported(QString);
        void defined(QString);
};

#endif
